--- libwebsock-2.0.0-original/src/websock.c	2014-07-15 08:52:39.000000000 +0900
+++ libwebsock-2.0.0/src/websock.c	2017-06-16 04:09:46.167781883 +0900
@@ -780,7 +780,7 @@
 	char sha1buf[45];
 	char concat[1024];
 	unsigned char sha1mac[20];
-	char *tok = NULL, *headers = NULL, *key = NULL;
+	char *tok = NULL, *headers = NULL, *key = NULL, *protocol = NULL;
 	char *base64buf = NULL;
 	const char *GID = "258EAFA5-E914-47DA-95CA-C5AB0DC85B11";
 	SHA1Context shactx;
@@ -795,8 +795,9 @@
 		if (strstr(tok, "Sec-WebSocket-Key: ") != NULL) {
 			key = (char *) lws_malloc(strlen(tok));
 			strncpy(key, tok + strlen("Sec-WebSocket-Key: "), strlen(tok));
-			break;
-		}
+		} else if(strstr(tok, "Sec-WebSocket-Protocol: ") != NULL) {
+      protocol = strdup(tok);
+    }
 	}
 #ifdef LIBWEBSOCK_DEBUG
 	fprintf(stderr, "[%s]: freeing headers at address: %p\n", __func__,
@@ -820,6 +821,12 @@
 		return;
 	}
 
+  if (protocol) {
+    char *comma = strchr(protocol, ',');
+    if(comma)
+      *comma = '\0';
+  }
+
 	memset(concat, 0, sizeof(concat));
 	strncat(concat, key, strlen(key));
 	strncat(concat, GID, strlen(GID));
@@ -843,13 +850,15 @@
 			"Server: %s/%s\r\n"
 			"Upgrade: websocket\r\n"
 			"Connection: Upgrade\r\n"
-			"Sec-WebSocket-Accept: %s\r\n\r\n", WEBSOCK_PACKAGE_NAME,
-			WEBSOCK_PACKAGE_VERSION, base64buf);
+			"Sec-WebSocket-Accept: %s\r\n%s%s\r\n", WEBSOCK_PACKAGE_NAME,
+			WEBSOCK_PACKAGE_VERSION, base64buf,
+      protocol ? protocol : "", protocol ? "\r\n" : "");
 #ifdef LIBWEBSOCK_DEBUG
 	fprintf(stderr, "[%s]: freeing base64buf at address: %p\n", __func__,
 			base64buf);
 #endif
 	lws_free(base64buf);
+  lws_free(protocol);
 
 	evbuffer_add(output, buf, strlen(buf));
 	bufferevent_setcb(bev, libwebsock_handle_recv, libwebsock_handle_send,
